
/*
 *
 * baubles.c - The baubles
 *
 */

#include "common.h"
#include "random.h"
#include "video.h"
#include "input.h"
#include "staticGeometry.h"
#include "baubles.h"
#include "game.h"
#include "particles.h"

// -----------------------------------------------------------------------
// variables
// -----------------------------------------------------------------------

// the baubles
struct bauble baubles[BAUBLES_MAX];

// -----------------------------------------------------------------------
// init the baubles
// -----------------------------------------------------------------------

void baublesInit(void) {

	int i;

	for (i = 0; i < BAUBLES_MAX; i++)
		baubles[i].type = BAUBLE_TYPE_NONE;
}

// -----------------------------------------------------------------------
// some of the baubles might do something
// -----------------------------------------------------------------------

void baublesIteration(float deltaTime) {

	float rX, rY;
	int i;

	for (i = 0; i < BAUBLES_MAX; i++) {
		if (baubles[i].type == BAUBLE_TYPE_NONE)
			continue;

		baubles[i].timer -= deltaTime;

		if (baubles[i].type == BAUBLE_TYPE_ROCK) {
			if (baubles[i].timer <= 0.0f) {
				rX = 0.1f * (randomNextInt() % 20);
				rY = 0.1f * (randomNextInt() % 20);
				particlesAdd(PARTICLE_TYPE_SMOKE_PIPE, baubles[i].cX + rX, baubles[i].cY + rY, baubles[i].cZ - 1550.0f, 0.0f, 0.0f, 0.02f);
				baubles[i].timer = (randomNextInt() & 511) + 256;
			}
		}
	}
}

// -----------------------------------------------------------------------
// draw the baubles
// -----------------------------------------------------------------------

void baublesDraw(void) {

	int i;

	for (i = 0; i < BAUBLES_MAX; i++) {
		if (baubles[i].type == BAUBLE_TYPE_NONE)
			continue;

		videoMatrixPush();

		videoTranslate3f(baubles[i].cX, baubles[i].cY, baubles[i].cZ - 1550.0f);
		videoRotate3f(0.0f, 0.0f, baubles[i].angle);
		videoScale3f(baubles[i].scale, baubles[i].scale, baubles[i].scale);

		if (baubles[i].type == BAUBLE_TYPE_ROCK)
			videoDrawMeshTextured(verticesRock, verticesRockTriangles);

		videoMatrixPop();
	}
}

// -----------------------------------------------------------------------
// add a bauble
// -----------------------------------------------------------------------

void baublesAdd(int type, float cX, float cY, float cZ, float scale, float angle) {

	int i;

	for (i = 0; i < BAUBLES_MAX; i++) {
		if (baubles[i].type == BAUBLE_TYPE_NONE) {
			baubles[i].type = type;
			baubles[i].cX = cX;
			baubles[i].cY = cY;
			baubles[i].cZ = cZ;
			baubles[i].scale = scale;
			baubles[i].angle = angle;
			baubles[i].timer = i*100.0f;
			return;
		}
	}
}
