
/*
 *
 * save.c - The save file manager
 *
 */

#include "common.h"
#include "save.h"
#include "file.h"
#include "game.h"

// -----------------------------------------------------------------------
// variables
// -----------------------------------------------------------------------

unsigned char saveData[256];

// -----------------------------------------------------------------------
// load the configuration
// -----------------------------------------------------------------------

void saveLoad(void) {

	int i, j;

	i = fileLoad("configuration.dat", saveData);
	if (i < 256)
		return;

	// check header
	if (saveData[0] != 'S' ||
			saveData[1] != 'A' ||
			saveData[2] != 'V' ||
			saveData[3] != SAVE_FILE_VERSION_NUMBER)
		return;

	i = 4;

	// player name
	playerNameN = saveData[i++];
	for (j = 0; j < playerNameN; j++)
		playerName[j] = saveData[i++];

	// server name
	serverNameN = saveData[i++];
	for (j = 0; j < serverNameN; j++)
		serverName[j] = saveData[i++];
}

// -----------------------------------------------------------------------
// save the configuration
// -----------------------------------------------------------------------

void saveSave(void) {

	int i, j;

	// create the configuration file
	i = 0;

	saveData[i++] = 'S';
	saveData[i++] = 'A';
	saveData[i++] = 'V';
	saveData[i++] = SAVE_FILE_VERSION_NUMBER;

	// player name
	saveData[i++] = playerNameN;
	for (j = 0; j < playerNameN; j++)
		saveData[i++] = playerName[j];

	// server name
	saveData[i++] = serverNameN;
	for (j = 0; j < serverNameN; j++)
		saveData[i++] = serverName[j];

	fileSave("configuration.dat", saveData, 256);
}
